import 'dart:convert';

import 'package:farm_tpf/custom_model/Harvest.dart';
import 'package:farm_tpf/data/api/app_exception.dart';
import 'package:farm_tpf/data/repository/repository.dart';
import 'package:farm_tpf/presentation/custom_widgets/app_bar_widget.dart';
import 'package:farm_tpf/presentation/custom_widgets/bloc/media_helper_bloc.dart';
import 'package:farm_tpf/presentation/custom_widgets/button_icon_widget.dart';
import 'package:farm_tpf/presentation/custom_widgets/button_widget.dart';
import 'package:farm_tpf/presentation/custom_widgets/widget_field_time_picker.dart';
import 'package:farm_tpf/presentation/custom_widgets/widget_loading.dart';
import 'package:farm_tpf/presentation/custom_widgets/widget_media_picker.dart';
import 'package:farm_tpf/presentation/custom_widgets/widget_text_field_description.dart';
import 'package:farm_tpf/presentation/custom_widgets/widget_text_form_field.dart';
import 'package:farm_tpf/presentation/custom_widgets/widget_utils.dart';
import 'package:farm_tpf/presentation/screens/actions/bloc/action_detail_bloc.dart';
import 'package:farm_tpf/presentation/screens/actions/harvest_process/sc_edit_action_harvest_process.dart';
import 'package:farm_tpf/presentation/screens/actions/packing/sc_edit_action_packing.dart';
import 'package:farm_tpf/presentation/screens/actions/sell/sc_edit_action_sell.dart';
import 'package:farm_tpf/presentation/screens/actions/state_management_helper/change_file_controller.dart';
import 'package:farm_tpf/presentation/screens/actions/util_action.dart';
import 'package:farm_tpf/utils/const_common.dart';
import 'package:farm_tpf/utils/const_icons.dart';
import 'package:farm_tpf/utils/const_string.dart';
import 'package:farm_tpf/utils/const_style.dart';
import 'package:farm_tpf/utils/pref.dart';
import 'package:farm_tpf/utils/validators.dart';
import 'package:flutter/material.dart';
import 'package:flutter_bloc/flutter_bloc.dart';
import 'package:flutter_datetime_picker/flutter_datetime_picker.dart';
import 'package:get/get.dart';
import 'package:intl/intl.dart';
import 'package:keyboard_dismisser/keyboard_dismisser.dart';
import 'package:pattern_formatter/pattern_formatter.dart';
import 'package:farm_tpf/utils/formatter.dart';

class EditActionHarvestScreen extends StatefulWidget {
  final int cropId;
  final bool isEdit;
  final int? activityId;
  EditActionHarvestScreen({required this.cropId, this.isEdit = false, this.activityId});
  @override
  _EditActionHarvestScreenState createState() => _EditActionHarvestScreenState();
}

class _EditActionHarvestScreenState extends State<EditActionHarvestScreen> {
  final GlobalKey<ScaffoldState> _scaffoldKey = GlobalKey<ScaffoldState>();
  final _repository = Repository();
  GlobalKey<FormState> _formKey = GlobalKey();
  bool _autoValidate = false;
  Harvest _harvest = Harvest();
  TextEditingController _l1Controller = TextEditingController();
  TextEditingController _l2Controller = TextEditingController();
  TextEditingController _l3Controller = TextEditingController();
  TextEditingController _removedQuantityController = TextEditingController();
  TextEditingController _descriptionController = TextEditingController();
  final _executeByController = TextEditingController();

  var pref = LocalPref();
  DateTime executeTime = DateTime.now();
  List<String> filePaths = <String>[];
  var changeFileController = Get.put(ChangeFileController());

  Future<Null> getSharedPrefs() async {
    var currentFullName = await pref.getString(DATA_CONST.CURRENT_FULL_NAME);
    _executeByController.text = currentFullName ?? "";
  }

  @override
  void initState() {
    super.initState();
    getSharedPrefs();
    changeFileController.initValue();
    _harvest.cropId = widget.cropId;
  }

  _validateInputs() async {
    if (_formKey.currentState!.validate()) {
      _formKey.currentState!.save();
      LoadingDialog.showLoadingDialog(context);
      filePaths = Get.find<ChangeFileController>().newFiles;
      try {
        _harvest.mediaDel = Get.find<ChangeFileController>().deleteFiles;
        var activityHarvest = jsonEncode(_harvest.toJson()).toString();
        //ADD NEW
        if (_harvest.activityId == null) {
          _repository.createAction((value) {
            LoadingDialog.hideLoadingDialog(context);
            Get.back(result: value);
            Utils.showSnackBarSuccess(message: label_add_success);
          }, (error) {
            LoadingDialog.hideLoadingDialog(context);
            Utils.showSnackBarError(message: AppException.handleError(error));
          },
              apiAddAction: ConstCommon.apiAddHarvest,
              paramActivity: ConstCommon.paramsActionHarvest,
              activityAction: activityHarvest,
              filePaths: filePaths);
        } else {
          //UPDATE
          _repository.updateAction((value) {
            LoadingDialog.hideLoadingDialog(context);
            Get.back(result: value);
            Utils.showSnackBarSuccess(message: label_update_success);
          }, (error) {
            LoadingDialog.hideLoadingDialog(context);
            Utils.showSnackBarError(message: AppException.handleError(error));
          },
              apiUpdateAction: ConstCommon.apiUpdateHarvest,
              paramActivity: ConstCommon.paramsActionHarvest,
              activityAction: activityHarvest,
              filePaths: filePaths);
        }
      } catch (e) {
        LoadingDialog.hideLoadingDialog(context);
        print(e.toString());
      }
    } else {
      _autoValidate = true;
    }
  }

  Widget _btnExecuteTimePicker() {
    return WidgetFieldDateTimePicker(
        initDateTime: executeTime,
        onUpdateDateTime: (selectedDate) {
          _harvest.executeDate = selectedDate.convertLocalDateTimeToStringUtcDateTime();
        });
  }

  Widget _l1Field() {
    return WidgetTextFormFieldNumber(
      hintValue: "Số lượng/khối lượng loại 1",
      textController: _l1Controller,
      onSaved: (newValue) {
        _harvest.collectedQuantityLv1 = (newValue ?? '0').parseDoubleThousand();
      },
      onChanged: (_) {},
      validator: (_) {},
    );
  }

  Widget _l2Field() {
    return WidgetTextFormFieldNumber(
      hintValue: "Số lượng/khối lượng loại 2",
      textController: _l2Controller,
      onSaved: (newValue) {
        _harvest.collectedQuantityLv2 = (newValue ?? '0').parseDoubleThousand();
      },
      onChanged: (_) {},
      validator: (_) {},
    );
  }

  Widget _l3Field() {
    return WidgetTextFormFieldNumber(
      hintValue: "Số lượng/khối lượng loại 3",
      textController: _l3Controller,
      onSaved: (newValue) {
        _harvest.collectedQuantityLv3 = (newValue ?? '0').parseDoubleThousand();
      },
      onChanged: (_) {},
      validator: (_) {},
    );
  }

  Widget _removedQuantityField() {
    return WidgetTextFormFieldNumber(
      hintValue: "Số lượng/khối lượng loại bỏ",
      textController: _removedQuantityController,
      onSaved: (newValue) {
        _harvest.removedQuantity = (newValue ?? '0').parseDoubleThousand();
      },
      onChanged: (_) {},
      validator: (_) {},
    );
  }

  Widget _descriptionField() {
    return TextFieldDescriptionWidget(
        controller: _descriptionController,
        onSaved: (newValue) {
          _harvest.description = newValue;
        });
  }

  Widget _executeByField() {
    return TextFormField(
      keyboardType: TextInputType.text,
      decoration: const InputDecoration(labelText: "Người thực hiện"),
      enabled: false,
      controller: _executeByController,
      onSaved: (newValue) {},
    );
  }

  @override
  Widget build(BuildContext context) => KeyboardDismisser(
          gestures: [
            GestureType.onTap,
            GestureType.onPanUpdateDownDirection,
          ],
          child: Scaffold(
              backgroundColor: Colors.white,
              key: _scaffoldKey,
              appBar: AppBarWidget(
                isBack: true,
                action: InkWell(
                  child: const Text(
                    'Huỷ',
                    style: TextStyle(color: Colors.red, fontWeight: FontWeight.normal),
                  ),
                  onTap: () {
                    if (Get.isSnackbarOpen) Get.back();
                    Get.back();
                  },
                ),
              ),
              body: KeyboardDismisser(
                  child: MultiBlocProvider(
                providers: [
                  BlocProvider<ActionDetailBloc>(
                    create: (context) => ActionDetailBloc(repository: Repository())
                      ..add(
                        FetchData(
                          isNeedFetchData: widget.isEdit,
                          apiActivity: ConstCommon.apiDetailHarvest,
                          activityId: widget.activityId ?? -1,
                        ),
                      ),
                  ),
                  BlocProvider<MediaHelperBloc>(
                    create: (context) => MediaHelperBloc()..add(ChangeListMedia(items: [])),
                  )
                ],
                child: Form(
                    key: _formKey,
                    // autovalidate: _autoValidate,
                    child: SafeArea(
                      child: SingleChildScrollView(
                        child: BlocConsumer<ActionDetailBloc, ActionDetailState>(
                          listener: (context, state) async {
                            if (state is ActionDetailFailure) {
                              LoadingDialog.hideLoadingDialog(context);
                            } else if (state is ActionDetailSuccess) {
                              LoadingDialog.hideLoadingDialog(context);
                              print(state.item);
                              _harvest = Harvest.fromJson(state.item);
                              _harvest.activityId = widget.activityId ?? -1;
                              _l1Controller.text = _harvest.collectedQuantityLv1?.formatNumtoStringDecimal() ?? '';
                              _l2Controller.text = _harvest.collectedQuantityLv2?.formatNumtoStringDecimal() ?? '';
                              _l3Controller.text = _harvest.collectedQuantityLv3?.formatNumtoStringDecimal() ?? '';
                              _removedQuantityController.text = _harvest.removedQuantity?.formatNumtoStringDecimal() ?? '';
                              _descriptionController.text = _harvest.description ?? "";
                              _executeByController.text = _harvest.executeBy ?? '';

                              Get.find<ChangeDateTimePicker>()
                                  .change(_harvest.executeDate?.convertStringServerDateTimeToLocalDateTime() ?? DateTime.now());
                              //Show media
                              if (Validators.stringNotNullOrEmpty(_harvest.media ?? '')) {
                                BlocProvider.of<MediaHelperBloc>(context)
                                    .add(ChangeListMedia(items: UtilAction.convertFilePathToMedia(_harvest.media ?? '')));
                              }
                            } else if (state is ActionDetailInitial) {
                            } else if (state is ActionDetailLoading) {
                              LoadingDialog.showLoadingDialog(context);
                            }
                          },
                          builder: (context, state) {
                            return Column(
                              children: [
                                Padding(
                                  padding: const EdgeInsets.all(8.0),
                                  child: Column(
                                    crossAxisAlignment: CrossAxisAlignment.start,
                                    children: <Widget>[
                                      const Text(
                                        plot_action_harvest,
                                        style: TextStyle(fontWeight: FontWeight.w500, fontSize: 22),
                                      ),
                                      const SizedBox(
                                        height: 8.0,
                                      ),
                                      Container(
                                        width: double.infinity,
                                        child: const Text(
                                          "Ngày thực hiện *",
                                          style: TextStyle(color: Colors.black54, fontSize: 13.0),
                                        ),
                                      ),
                                      _btnExecuteTimePicker(),
                                      const SizedBox(
                                        height: 8.0,
                                      ),
                                      _l1Field(),
                                      const SizedBox(
                                        height: 8.0,
                                      ),
                                      _l2Field(),
                                      const SizedBox(
                                        height: 8.0,
                                      ),
                                      _l3Field(),
                                      const SizedBox(
                                        height: 8.0,
                                      ),
                                      _removedQuantityField(),
                                      const SizedBox(
                                        height: 8.0,
                                      ),
                                      _descriptionField(),
                                      const SizedBox(
                                        height: 8.0,
                                      ),
                                      _executeByField(),
                                      const SizedBox(
                                        height: 8.0,
                                      ),
                                    ],
                                  ),
                                ),
                                Container(
                                  width: double.infinity,
                                  height: 16,
                                  color: Colors.grey[200],
                                ),
                                BlocBuilder<MediaHelperBloc, MediaHelperState>(builder: (context, state) {
                                  if (state is MediaHelperSuccess) {
                                    return WidgetMediaPicker(
                                        currentItems: state.items,
                                        onChangeFiles: (newPathFiles, deletePathFiles) async {
                                          Get.find<ChangeFileController>().change(newPathFiles, deletePathFiles);
                                        });
                                  } else {
                                    return const Center(child: CircularProgressIndicator());
                                  }
                                }),
                                Container(
                                  width: double.infinity,
                                  height: 16,
                                  color: Colors.grey[200],
                                ),
                                ButtonIconWidget(
                                    leadingIcon: AppIcons.icHarvestProcess,
                                    trailingIcon: AppIcons.icArrowRight,
                                    title: plot_action_harvest_process,
                                    onTap: () {
                                      if (_harvest.id != null) {
                                        Get.to(EditActionHarvestProcessScreen(
                                          cropId: widget.cropId,
                                          harvestId: _harvest.id,
                                        ));
                                      } else {
                                        Get.to(EditActionHarvestProcessScreen(cropId: widget.cropId));
                                      }
                                    }),
                                ButtonIconWidget(
                                    leadingIcon: AppIcons.icPacking,
                                    trailingIcon: AppIcons.icArrowRight,
                                    title: plot_action_packing,
                                    onTap: () {
                                      if (_harvest.id != null) {
                                        Get.to(EditActionPackingScreen(
                                          cropId: widget.cropId,
                                          harvestId: _harvest.id,
                                        ));
                                      } else {
                                        Get.to(EditActionPackingScreen(cropId: widget.cropId));
                                      }
                                    }),
                                ButtonIconWidget(
                                    leadingIcon: AppIcons.icSell,
                                    trailingIcon: AppIcons.icArrowRight,
                                    title: plot_action_sell,
                                    onTap: () {
                                      if (_harvest.id != null) {
                                        Get.to(EditActionSellScreen(
                                          cropId: widget.cropId,
                                          harvestId: _harvest.id,
                                        ));
                                      } else {
                                        Get.to(EditActionSellScreen(cropId: widget.cropId));
                                      }
                                    }),
                                const SizedBox(
                                  height: 16,
                                ),
                                Padding(
                                  padding: const EdgeInsets.all(8.0),
                                  child: ButtonWidget(
                                      title: 'CẬP NHẬT',
                                      onPressed: () {
                                        var currentFocus = FocusScope.of(context);
                                        if (!currentFocus.hasPrimaryFocus) {
                                          currentFocus.unfocus();
                                        }
                                        _validateInputs();
                                      }),
                                ),
                              ],
                            );
                          },
                        ),
                      ),
                    )),
              ))));
  @override
  void dispose() {
    _l1Controller.dispose();
    _l2Controller.dispose();
    _l3Controller.dispose();
    _removedQuantityController.dispose();
    _descriptionController.dispose();
    _executeByController.dispose();
    super.dispose();
  }
}
